<?php

/**
 * inf_nota_debito actions.
 *
 * @package    cartera
 * @subpackage inf_nota_debito
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class inf_nota_debitoActions extends sfQuery {

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Metodo para listar el informe nota debito
     *
     * @param sfWebRequest $request
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------/  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        //manejo de errores
        try {

            /*
             * Variables obligatorias
             */
            $fecha_ini = $request['fecha_ini'];
            $fecha_fin = $request['fecha_fin'];
            if (isset($request['estado'])) {
                if ($request['estado'] == 'false') {
                    $estado = 0;
                    $whereEstado = " and (case when Tab0.fecha_anu<=last_day(to_date('" . $fecha_ini . "', 'YYYY-MM-DD')) then 0 else 1 END  = " . $estado . ") ";
                } else {
                    $estado = 1;
                    $whereEstado = " and (case when Tab0.fecha_anu<=last_day(to_date('" . $fecha_ini . "', 'YYYY-MM-DD')) then 0 else 1 END  = " . $estado . ") ";
                }
            } else {
                $estado = 1;
                $whereEstado = " and (case when Tab0.fecha_anu_cre<=last_day(to_date('" . $fecha_ini . "', 'YYYY-MM-DD')) then 0 else 1 END  = " . $estado . ") ";
            }
            //punto venta
            if (isset($request['id_punto_venta'])) {
                $wherePuntoVenta = " AND tab0.id_punto_venta = " . $request['id_punto_venta'];
            } else {
                $wherePuntoVenta = ' ';
            }

            /*
             * Variables opcionales
             */
            //tercero
            if (isset($request['id_mae_ter'])) {
                $whereTercero = " AND tab0.id_mae_ter = " . $request['id_mae_ter'];
            } else {
                $whereTercero = ' ';
            }
            //tipo debito
            if (isset($request['id_tipo_debito'])) {
                $whereTipoDebito = " AND tab0.id_tipo_debito = " . $request['id_tipo_debito'];
            } else {
                $whereTipoDebito = ' ';
            }
            //producto - 20140409
            if (isset($request['id_producto'])) {
                $whereProducto = " AND tab0.id_producto = " . $request['id_producto'];
            } else {
                $whereProducto = ' ';
            }
            //secuencia - 20161121
            if (isset($request['sec_debito'])){
                $whereSecuencia = " AND tab0.sec_debito = " . $request['sec_debito']; 
            }
            else {
                $whereSecuencia = ' ';
            }

            /*
             * Paginacion
             */
            if (isset($request['_startRow'])) {
                $rowStart = $request['_startRow'];
            } else {
                $rowStart = 0;
            }

            if (isset($request['_endRow'])) {
                $rowEnd = $request['_endRow'];
            } else {
                $rowEnd = 200;
            }

            /*
             * Formato de fecha sin time
             */
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;

            CN_TABLE::executeSQL($sql);


            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            /*
              To_Char(Tab0.Fecha_Proceso, 'YYYY-MM-DD') Between '$fecha_ini' And '$fecha_fin'
              and Tab0.estado = $estado
              $whereTercero
             */
            $sql = <<<EOD

select count(*) as count from (


Select * From (

Select distinct

1 as Orden,
Null  As Id_Debito,
null  as Id_Debito_Detalle,
Id_Producto,
Codigo_Pro,
Descripcion_Pro,
null  as Sec_Debito,
null  as Fecha_Proceso,
-1 as Id_Mae_Ter,
null  as Num_Doc,
Null  As Razon_Soc,
'NOTA DEBITO: ' || Codigo_Pro || ' - ' || Descripcion_Pro As Tercero,
null  as valor_total,
null  as Fecha_Anu,
null  as Motivo_Anu,
null  as Estado,
Null  As Id_Tipo_Debito,
null  as Tipo_Debito

FROM(

select
*
From Ca_Debito_Producto Tab0

Where
To_Char(Tab0.Fecha_Proceso, 'YYYY-MM-DD') Between '$fecha_ini' And '$fecha_fin'
$whereEstado $whereTercero $whereTipoDebito $wherePuntoVenta $whereProducto $whereSecuencia
                    

Order By
Tab0.Codigo_Pro,
Tab0.Sec_Debito

)
/*
Order By
Codigo_Pro
*/
union

Select

3 as Orden,
Null  As Id_Debito,
null  as Id_Debito_Detalle,
Id_Producto,
Codigo_Pro,
Descripcion_Pro,
null  as Sec_Debito,
null  as Fecha_Proceso,
-1 as Id_Mae_Ter,
null  as Num_Doc,
Null  As Razon_Soc,
'TOTAL NOTA DEBITO: ' || Codigo_Pro || ' - ' || Descripcion_Pro as Tercero,
sum(Valor_Total) as valor_total,
null  as Fecha_Anu,
null  as Motivo_Anu,
null  as Estado,
Null  As Id_Tipo_Debito,
null  as Tipo_Debito

FROM(

select
*
From Ca_Debito_Producto Tab0

Where
To_Char(Tab0.Fecha_Proceso, 'YYYY-MM-DD') Between '$fecha_ini' And '$fecha_fin'
$whereEstado $whereTercero $whereTipoDebito $wherePuntoVenta $whereProducto $whereSecuencia

Order By
Tab0.Codigo_Pro,
Tab0.Sec_Debito

)

Group By
Id_Producto,
Codigo_Pro,
Descripcion_Pro

Union

Select

2 as Orden,
Tab0.Id_Debito,
Tab0.Id_Debito_Detalle,
Tab0.Id_Producto,
Tab0.Codigo_Pro,
Tab0.Descripcion_Pro,
Tab0.Sec_Debito,
Tab0.Fecha_Proceso,
Tab0.Id_Mae_Ter,
Tab0.Num_Doc,
Tab0.Razon_Soc,
Tab0.Tercero,
Tab0.Valor_Total,
Tab0.Fecha_Anu,
Tab0.Motivo_Anu,
Tab0.Estado,
Tab0.Id_Tipo_Debito,
Tab0.Tipo_Debito

From Ca_Debito_Producto Tab0

Where
To_Char(Tab0.Fecha_Proceso, 'YYYY-MM-DD') Between '$fecha_ini' And '$fecha_fin'
$whereEstado $whereTercero $whereTipoDebito $wherePuntoVenta $whereProducto $whereSecuencia
/*
Order By
Tab0.Codigo_Pro,
Tab0.Sec_Debito
*/

)

Order By
Codigo_Pro,
Orden,
Sec_Debito,
Id_Mae_Ter

)

EOD;


            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];


            //obtener el listado de recaudos
            $sql = <<<EOD

SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (


Select * From (

Select distinct

1 as Orden,
Null  As Id_Debito,
null  as Id_Debito_Detalle,
Id_Producto,
Codigo_Pro,
Descripcion_Pro,
null  as Sec_Debito,
null  as Fecha_Proceso,
-1 as Id_Mae_Ter,
null  as Num_Doc,
Null  As Razon_Soc,
'NOTA DEBITO: ' || Codigo_Pro || ' - ' || Descripcion_Pro As Tercero,
null  as valor_total,
null  as Fecha_Anu,
null  as Motivo_Anu,
null  as Estado,
Null  As Id_Tipo_Debito,
null  as Tipo_Debito

FROM(

select
*
From Ca_Debito_Producto Tab0

Where
To_Char(Tab0.Fecha_Proceso, 'YYYY-MM-DD') Between '$fecha_ini' And '$fecha_fin'
$whereEstado $whereTercero $whereTipoDebito $wherePuntoVenta $whereProducto $whereSecuencia

Order By
Tab0.Codigo_Pro,
Tab0.Sec_Debito

)
/*
Order By
Codigo_Pro
*/
union

Select

3 as Orden,
Null  As Id_Debito,
null  as Id_Debito_Detalle,
Id_Producto,
Codigo_Pro,
Descripcion_Pro,
null  as Sec_Debito,
null  as Fecha_Proceso,
-1 as Id_Mae_Ter,
null  as Num_Doc,
Null  As Razon_Soc,
'TOTAL NOTA DEBITO: ' || Codigo_Pro || ' - ' || Descripcion_Pro as Tercero,
sum(Valor_Total) as valor_total,
null  as Fecha_Anu,
null  as Motivo_Anu,
null  as Estado,
Null  As Id_Tipo_Debito,
null  as Tipo_Debito

FROM(

select
*
From Ca_Debito_Producto Tab0

Where
To_Char(Tab0.Fecha_Proceso, 'YYYY-MM-DD') Between '$fecha_ini' And '$fecha_fin'
$whereEstado $whereTercero $whereTipoDebito $wherePuntoVenta $whereProducto $whereSecuencia

Order By
Tab0.Codigo_Pro,
Tab0.Sec_Debito

)

Group By
Id_Producto,
Codigo_Pro,
Descripcion_Pro

Union

Select

2 as Orden,
Tab0.Id_Debito,
Tab0.Id_Debito_Detalle,
Tab0.Id_Producto,
Tab0.Codigo_Pro,
Tab0.Descripcion_Pro,
Tab0.Sec_Debito,
Tab0.Fecha_Proceso,
Tab0.Id_Mae_Ter,
Tab0.Num_Doc,
Tab0.Razon_Soc,
Tab0.Tercero,
Tab0.Valor_Total,
Tab0.Fecha_Anu,
Tab0.Motivo_Anu,
Tab0.Estado,
Tab0.Id_Tipo_Debito,
Tab0.Tipo_Debito

From Ca_Debito_Producto Tab0

Where
To_Char(Tab0.Fecha_Proceso, 'YYYY-MM-DD') Between '$fecha_ini' And '$fecha_fin'
$whereEstado $whereTercero $whereTipoDebito $wherePuntoVenta $whereProducto $whereSecuencia
/*
Order By
Tab0.Codigo_Pro,
Tab0.Sec_Debito
*/

)

Order By
Codigo_Pro,
Orden,
Sec_Debito,
Id_Mae_Ter

) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart

EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $this->startRow + count($resultado);
            $this->list_data = $resultado;
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

    /**
     * Metodo para sumar el informe nota debito
     *
     * @param sfWebRequest $request
     */
    public function executeSum(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------/  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        //manejo de errores
        try {

            /*
             * Variables obligatorias
             */
            $fecha_ini = $request['fecha_ini'];
            $fecha_fin = $request['fecha_fin'];
            if (isset($request['estado'])) {
                if ($request['estado'] == 'false') {
                    $estado = 0;
                    $whereEstado = " and (case when Tab0.fecha_anu<=last_day(to_date('" . $fecha_ini . "', 'YYYY-MM-DD')) then 0 else 1 END  = " . $estado . ") ";
                } else {
                    $estado = 1;
                    $whereEstado = " and (case when Tab0.fecha_anu<=last_day(to_date('" . $fecha_ini . "', 'YYYY-MM-DD')) then 0 else 1 END  = " . $estado . ") ";
                }
            } else {
                $estado = 1;
                $whereEstado = " and (case when Tab0.fecha_anu_cre<=last_day(to_date('" . $fecha_ini . "', 'YYYY-MM-DD')) then 0 else 1 END  = " . $estado . ") ";
            }
            //punto venta
            if (isset($request['id_punto_venta'])) {
                $wherePuntoVenta = " AND tab0.id_punto_venta = " . $request['id_punto_venta'];
            } else {
                $wherePuntoVenta = ' ';
            }

            /*
             * Variables opcionales
             */
            //tercero
            if (isset($request['id_mae_ter'])) {
                $whereTercero = " AND tab0.id_mae_ter = " . $request['id_mae_ter'];
            } else {
                $whereTercero = ' ';
            }
            //tipo debito
            if (isset($request['id_tipo_debito'])) {
                $whereTipoDebito = " AND tab0.id_tipo_debito = " . $request['id_tipo_debito'];
            } else {
                $whereTipoDebito = ' ';
            }
            //producto - 20140409
            if (isset($request['id_producto'])) {
                $whereProducto = " AND tab0.id_producto = " . $request['id_producto'];
            } else {
                $whereProducto = ' ';
            }
            
             //secuencia - 20161121
            if (isset($request['sec_debito'])){
                $whereSecuencia = " AND tab0.sec_debito = " . $request['sec_debito']; 
            }
            else {
                $whereSecuencia = ' ';
            }

            /*
             * Paginacion
             */
            if (isset($request['_startRow'])) {
                $rowStart = $request['_startRow'];
            } else {
                $rowStart = 0;
            }

            if (isset($request['_endRow'])) {
                $rowEnd = $request['_endRow'];
            } else {
                $rowEnd = 200;
            }


            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT

   count(*) as sec_debito,
   'TOTALES NOTAS DEBITO' as razon_soc,

   SUM(VALOR_TOTAL_DEBDET)  as Valor_Total

FROM (

Select

2 as Orden,
Tab0.Id_Debito,
Tab0.Id_Debito_Detalle,
Tab0.Id_Producto,
Tab0.Codigo_Pro,
Tab0.Descripcion_Pro,
Tab0.Sec_Debito,
Tab0.Fecha_Proceso,
Tab0.Id_Mae_Ter,
Tab0.Num_Doc,
Tab0.Razon_Soc,
Tab0.Tercero,
Tab0.Valor_Total,
Tab0.Fecha_Anu,
Tab0.Motivo_Anu,
Tab0.Estado,
Tab0.Id_Tipo_Debito,
Tab0.Tipo_Debito
,tab0.VALOR_TOTAL_DEBDET

From Ca_Debito_Producto Tab0

Where
To_Char(Tab0.Fecha_Proceso, 'YYYY-MM-DD') Between '$fecha_ini' And '$fecha_fin'
$whereEstado $whereTercero $whereTipoDebito $wherePuntoVenta $whereProducto $whereSecuencia
/*
Order By
Tab0.Codigo_Pro,
Tab0.Sec_Debito
*/

)

EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = count($resultado);
            $this->startRow = 0;
            $this->endRow = count($resultado);
            $this->list_data = $resultado;
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
